
/* README FILE
 *  
 * Version & Program Information
 * 
 * Author: Flavio Spedalieri, Nightlase Technologies Sydney NSW Australia
 * Project: Coffee Grinder Timer
 * 
 */

/*
  Version History & Development
  -----------------------------

    V2.82 - Date: 21.05.2020 - Release 1
    ------------------------------------
    Addition of LED control for Program Button & Manual Button
    Remapping of PIN Assignment.
    
    V2.81 - Date: 17.05.2020 - Release 1
    ------------------------------------
    Support Implementation for Digole DS12864OLED-2W OLED display
      Build Code 6 implimentation - 1B_DS12864OLED (BC6). 
    Update of clock icon graphic.
    Minor changes & refindments of code.

    V2.80 - Date: 15.05.2020 - Release 1 - 1B_128x64OLED (BC4)
    ----------------------------------------------------------
    Clean up of code & final testing.
    Issue with LED Fade & display update resolved by reposition and setup of 
    "grinderRunTime1" which initially was causing constant refresh which affected
    the PWM output (i.e pusling in LED fade).

    ver.s 2.76 - 2.79 reserved for further development. 

    V2.75 - Date: 14.05.2020 - Bug fixes and trial of Build Code 5 development 
    --------------------------------------------------------------------------
      Resolve issues with LED fade & visible pulsing in "breathing LED" 
      (idle mode) caused by U8G2 display writes & on-the-fly offset feature 
      (timer offset). Display update in timer offset function set to update 
      once per change.

      Consolidation of timer states into single "timerState" variable.

      Added features: 
        Sleep LED function (dim flashing LED)
        Initial test Coding for Digole DS12864OLED-2W OLED (WIP)
  
    V2.74 - Date: 5.04.2020 - 1-Button (P1) 128x64 OLED Display (BC4)
    --------------------------------------------------------------------------
      Addition of SPI version for 128x64 (1.3") display for SH1106.

    V2.73 - Date: 03.05.2020 - 1-Button (P1) 16x2 Character OLED Display (BC5)
    ----------------------------------------------------------------------------------
      Build Code 5: Code Implementation for 16x2 character OLED; Newhaven NHD-0216AW-IB3

    V2.72 - Date: 30.04.2020 - 1-Button (P1) 128x64 OLED Display (BC4)
    --------------------------------------------------------------------------
      Build Code 4: Code implementation for 128x64 OLED Display

    V2.71 - Date: 27.04.2020
    --------------------------------
      Implementation of OLED screen saver / power save mode to turn off display after preset time
      (see OLED power save section, variable "screenSaverTimer").

    V2.70 - Date: 27.04.2020
    --------------------------------
      Software ported for 128x64 Monochrome OLED Display
      Feature code: 1B_128x64OLED (FC3)

    V2.65 - Date: 14.04.2020
    --------------------------------
      (Ver.2.65)
      Single button configuration (refer Button section).
      While in '<OFFSET> mode', single click of P1 will exit mode and return to normal preset mode
      Double click of P1 to swap between presets (immediatly after exiting '<OFFSET> mode').
      If not use offset mode, only single click needed to swap between Preset 1 & Preset 2

      (Ver.2.64)
      2 button configuration (refer Button section).

    V2.51 - Date: 06.04.2020
    --------------------------------
    Code Clean up.

    V2.50 - Date: 03.04.2020
    --------------------------------
      SSR set to Pin 13.
      Added LED visual features, PIN 10.
        3 sec fade in at boot.
        3 sec fade in / out of activate buttion - Idle Mode
        LED off while timer is active.
        Gp.Fl(3)0.1s while in manual mode
        Oc(10)for encoder long press, then flash once on exit (after firmware display).
        Fl(1) when P1 pressed, Fl(2) when P2 pressed.
        Fl(3) on save to EEPROM.

    V2.40 - Date: 02.04.2020
    --------------------------------
      P1 Button Functionality;
       Short press maintained to select preset 1. 3 sec Press will allow use to enable / disable start-up screen. Value saved to EEPROM.
      Encoder Button Long Press;
       2 sec press of encoder button will display (for 4 sec) firmware version details on LCD.

    V2.36 - Date: 01.04.2020
    --------------------------------
      Development version to build configuration UI. Attempted to combine P1 & P1 to single button. Some success, however P1 / P2
      toggle not reliable. Two buttons retained. Encoder button Long Press added to display firmware details.

    V2.30 - Date: 20.03.2020
    --------------------------------
    Encoder functionality;
      Idle mode; able to adjust an "offset" time ( "<OFFSET" "PRESET" "OFFSET>" ) shown on display as encoder is rotated.
      Grinder can be operated for the shown offset time. - A good feature during calibration of dose.
      Exit from offset mode by pressing the preset selection button (P1 or P2) accordingly. The offset value is not stored at this point.
      Clicking the encoder button will enter the program mode, the offset value will be updated and stored.

    V2.20 - Date: 19.03.2020
    --------------------------------
      Display: 16x2 LCD
      Added encoder control feature;
        Adjust of program time by rotating encoder.
        Encoder button click to enter programming.

 -- End of File -- 
 */


    
